"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const ServerDataContext_1 = require("./ServerDataContext");
const server_1 = require("react-dom/server");
class ServerDataTag extends React.PureComponent {
    renderTags() {
        return __awaiter(this, void 0, void 0, function* () {
            const { children } = this.props;
            if (!children) {
                return;
            }
            if (typeof children !== "function") {
                throw new Error("PushDataTags must be provided a function");
            }
            const action = this.props.action;
            if (!action) {
                return server_1.renderToString(children());
            }
            const args = this.props.args || [];
            return server_1.renderToString(children(yield this.context.getResult(action, ...args))).replace(/<!-- -->/g, "");
        });
    }
    componentDidMount() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.context.firstRun || !document.head) {
                return;
            }
            const { children, action } = this.props;
            if (!children) {
                return;
            }
            if (typeof children !== "function") {
                throw new Error("PushDataTags must be provided a function");
            }
            let newHead = "";
            if (!action) {
                newHead = server_1.renderToString(children());
            }
            else {
                const args = this.props.args || [];
                newHead = server_1.renderToString(children(yield ServerDataContext_1.ServerDataStore.getResult(action, ...args))).replace(/<!-- -->/g, "");
            }
            const oldItems = document.head.querySelectorAll("[data-reactroot]");
            oldItems.forEach((item) => {
                if (item) {
                    const parent = item.parentNode;
                    if (parent) {
                        parent.removeChild(item);
                    }
                }
            });
            document.head.innerHTML += newHead;
        });
    }
    render() {
        if (this.props.action) {
            const args = this.props.args || [];
            this.context.runAction(this.props.action, ...args);
        }
        this.context.registerTagRenderer(this);
        return null;
    }
}
ServerDataTag.contextType = ServerDataContext_1.ServerDataContext;
exports.default = ServerDataTag;
//# sourceMappingURL=ServerDataTag.js.map